/*
xshwfnt Version 0.2.0 - Show X Windows Font
Copyright (C) 2001-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/* to define the escape key */
#define XK_MISCELLANY 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/times.h>
#include <X11/Xlib.h>
#include <X11/keysymdef.h>
#include <assert.h>
#include <unistd.h>

#define HDRFONT "10x20"
#define NIL (0)
#define SCRLFONT 'f'
#define FONTBEG  'b'
#define NEXTFONT 'n'
#define PREVFONT 'p'

int whiteColor,blackColor;
int runflg,expflg,prevflg,strtflg;
int nextflg,scrlflg;
Display *dpy;
Window w;
GC gc;
Font fontid;
Font fnt10x20;
XFontStruct *str7x14;
int rootww;                      /* root    window width  */
int rootwh;                      /* root    window height */
int dpywdth;                     /* display window width  */
int dpyhght;                     /* display window height */


void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage: %s <fontname>\n",
      pgm);
   exit(1);
   } /* putstx */

/* X Windows code is based on: */
/* http://tronche.lri.fr:8000/gui/x/xlib-tutorial/2nd-program-anatomy.html */

void getkey()
   {
   int i,rslt,msk;
   int symbol;
   int XCheckMaskEvent();
   XEvent e;
   XKeyEvent *k;

   msk = KeyPressMask|ExposureMask;

   XSelectInput(dpy, w, msk);

   while (1)
      {
      XNextEvent(dpy,&e);
      expflg = prevflg = strtflg = 0;
      scrlflg = nextflg = 0;
      runflg = 1;
      if (e.type == KeyPress)
         {
         k = (XKeyEvent *) &e;
         symbol = XLookupKeysym(k,0);
         symbol = tolower(symbol);
         if (symbol == XK_Escape)
            {
            runflg = 0;
            break;
            } /* if quit */
         else if (symbol == NEXTFONT)
            {
            nextflg = 1;
            break;
            } /* if quit */
         else if (symbol == SCRLFONT)
            {
            scrlflg = 1;
            break;
            } /* if quit */
         else if (symbol == PREVFONT)
            {
            prevflg = 1;
            break;
            } /* if quit */
         else if (symbol == FONTBEG)
            {
            strtflg = 1;
            break;
            } /* if quit */
         } /* if keypress event */
      else if (e.type == Expose)
         {
         expflg = 1;
         break;
         } /* if expose event */
      } /* if event received */
   } /* getkey */

void initx()
   {
   int i,rslt;
   char title[64];

   dpy = XOpenDisplay(NIL);

   if (dpy == NULL)
      {
      fprintf(stderr,"X Windows failure\n");
      exit(1);
      } /* if X Windows is not active */

   assert(dpy);

   rootww  = XDisplayWidth(dpy,0);
   rootwh  = XDisplayHeight(dpy,0);
   dpywdth = rootww -  80;
   dpyhght = rootwh - 100;

   whiteColor = WhitePixel(dpy, DefaultScreen(dpy));
   blackColor = BlackPixel(dpy, DefaultScreen(dpy));

   w = XCreateSimpleWindow(dpy,
      DefaultRootWindow(dpy),
      0, 0, 
      dpywdth, dpyhght,
      0, whiteColor,
      whiteColor);

   XSelectInput(dpy, w, StructureNotifyMask);

   XMapWindow(dpy, w);

   gc = XCreateGC(dpy, w, 0, NIL);

   /* fontid = (Font) XLoadFont(dpy,"linux8x16"); */

   /* XSetFont(dpy,gc,fontid); */

   XSetForeground(dpy, gc, blackColor);

   XSetWindowBorderWidth(dpy, w, 40);

   sprintf(title,"xshwfnt");
   XStoreName(dpy,w,title);

   XMoveWindow(dpy,w,0,0);

   while(1)
      {
      XEvent e;
      XNextEvent(dpy, &e);
      if (e.type == MapNotify) break;
      } /* wait for window initialization */
   } /* initx */

void shwfont(fntname)
char *fntname;
   {
   int i,j,row,hght,hdrlen;
   int rowwdth,hdrwdth;
   Font fontid;
   XFontStruct *fntstr;
   char *p,*q,*r,*s;
   unsigned char str[384];
   unsigned char seg[64];
   hdrlen = strlen(fntname);
   XSetBackground(dpy, gc, whiteColor);
   XSetForeground(dpy, gc, blackColor);
   XSetFont(dpy,gc,fnt10x20);
   XDrawImageString(dpy,w,gc,10,40,fntname,hdrlen);
   fontid = (Font) XLoadFont(dpy,fntname);
   fntstr = (XFontStruct *) XQueryFont(dpy,fontid);
   hght = fntstr->ascent + fntstr->descent;
   XSetFont(dpy,gc,fontid);
   p = str;
   q = p + 256;
   i = 0;
   while (p < q) *p++ = i++;
   *p = '\0';
   p = str;
   *p = 32;
   r = seg;
   s = r + 32;
   row = 60 + hght;
   while (p < q)
      {
      strncpy(seg,p,32);
      *s = '\0';
      rowwdth = XTextWidth(fntstr,seg,32);
      /* 624 - 20 */
      if (rowwdth < 604)
         {
         XDrawImageString(dpy,w,gc,20,row,r,32);
         p += 32;
         } /* enough room on line */
      /* 1248 - 20 */
      else if (rowwdth < 1228)
         {
         XDrawImageString(dpy,w,gc,20,row,r,16);
         p += 16;
         } /* cut line in half */
      else
         {
         XDrawImageString(dpy,w,gc,20,row,r,8);
         p += 8;
         } /* cut line in half */
      row += (hght + 4);
      if ((row + hght + 4) > dpyhght && p < q)
         {
         getkey();
         if (nextflg || prevflg || !runflg) break;
         else if (strtflg) p = str;
         XClearWindow(dpy,w);
         row = 60 + hght;
         XSetFont(dpy,gc,fnt10x20);
         XDrawImageString(dpy,w,gc,10,40,fntname,hdrlen);
         XSetFont(dpy,gc,fontid);
         } /* next page */
      } /* for each 32 char in charset */
   if (runflg && !prevflg && !nextflg) getkey();
   XUnloadFont(dpy,fontid);
   XClearWindow(dpy,w);
   } /* shwfont */

int main(argc,argv)
int argc;
char **argv;
   {
   int i,fnts;
   char **font;
   char fontmask[256];
   if (argc != 2) putstx(*argv);
   strcpy(fontmask,*(argv+1));
   initx(fontmask);
   fnt10x20 = (Font) XLoadFont(dpy,HDRFONT);
   str7x14 = (XFontStruct *) XQueryFont(dpy,fnt10x20);
   font = (char **) XListFonts(dpy,fontmask,999999,&fnts);
   printf("\"%s\"  Total fonts %d\n", fontmask, fnts);
   runflg = 1;
   expflg = prevflg = strtflg = 0;
   for (i=0;runflg&&i<fnts;i++)
      {
      do
         { /* do while expose flag is set */
         do
            {
            prevflg = strtflg = expflg =
               nextflg = scrlflg = 0;
            shwfont(font[i]);
            if (prevflg) i--;
            if (i < 0) i = 0;
            } while (prevflg || strtflg);
         } while (expflg);
      } /* for each font */
   XFreeFontInfo(NULL,str7x14,1);
   XUnloadFont(dpy,fnt10x20);
   return(0);
   } /* main */
